package log

import "LAPP_GAAS_GFrame_BACKEND/grmi"

/******************************************************************************
 *
 * @Struct Name              : ArtDemandLstResponseItem
 *-----------------------------------------------------------------------------
 *
 * @Description              : ArtDemandLst列表页返回前端结构体
 *
 * @Author                   : 张鑫
 *
 * @Date                     : 2021-03-30
 *
 ******************************************************************************/
type ArtDemandLstResponseItem struct {
	*ArtDemandLst
	ArtDesc       string `json:"LOG_ArtDemandLst-ArtDesc"`       // 物料描述
	UrgencyDegree int    `json:"LOG_ArtDemandLst-UrgencyDegree"` // 紧急程度
	SurplusDays   int64  `json:"LOG_ArtDemandLst-SurplusDays"`   // 距离交付天数
}

/******************************************************************************
 *
 * @Struct Name              : ArtDemandHeadResponseItem
 *-----------------------------------------------------------------------------
 *
 * @Description              : ArtDemandHead列表页返回前端结构体
 *
 * @Author                   : 张鑫
 *
 * @Date                     : 2021-04-29
 *
 ******************************************************************************/
type ArtDemandHeadResponseItem struct {
	*ArtDemandHead
	ArtDesc       string `json:"LOG_ArtDemandHead-ArtDesc"`       // 物料描述
	UrgencyDegree int    `json:"LOG_ArtDemandHead-UrgencyDegree"` // 紧急程度
	SurplusDays   int64  `json:"LOG_ArtDemandHead-SurplusDays"`   // 距离交付天数
}

//TODO 临时结构体 待解决
type ArtDemandLstResponseItemTemp struct {
	PlantNr            int           `xorm:"pk int 'PlantNr'" json:"LOG_ArtDemandLst-PlantNr"`
	ArtId              string        `xorm:"pk nvarchar(40) 'ArtId'" json:"LOG_ArtDemandLst-ArtId"`
	DemandTime         grmi.DateTime `xorm:"pk datetime2(0) 'DemandTime'" json:"LOG_ArtDemandLst-DemandTime"`
	DemandId           string        `xorm:"nvarchar(40) 'DemandId' not null" json:"LOG_ArtDemandLst-DemandId"`
	DemandYear         int           `xorm:"int 'DemandYear' not null" json:"LOG_ArtDemandLst-DemandYear"`
	DemandMonth        int           `xorm:"int 'DemandMonth' not null" json:"LOG_ArtDemandLst-DemandMonth"`
	DemandWeek         int           `xorm:"int 'DemandWeek' not null" json:"LOG_ArtDemandLst-DemandWeek"`
	DemandDate         grmi.Date     `xorm:"date 'DemandDate' not null" json:"LOG_ArtDemandLst-DemandDate"`
	DemandHour         int           `xorm:"int 'DemandHour' not null" json:"LOG_ArtDemandLst-DemandHour"`
	DemandQty          float64       `xorm:"float 'DemandQty' not null" json:"LOG_ArtDemandLst-DemandQty"`
	QtyUomId           string        `xorm:"nvarchar(40) 'QtyUomId' not null" json:"LOG_ArtDemandLst-QtyUomId"`
	DemandObjId        string        `xorm:"nvarchar(40) 'DemandObjId' not null" json:"LOG_ArtDemandLst-DemandObjId"`
	DemandType         string        `xorm:"nvarchar(40) 'DemandType' not null" json:"LOG_ArtDemandLst-DemandType"`
	Status             string        `xorm:"int 'Status' not null" json:"LOG_ArtDemandLst-Status"`
	DemandSendTime     grmi.DateTime `xorm:"datetime 'DemandSendTime'" json:"LOG_ArtDemandLst-DemandSendTime"`
	DemandRecieveTime  grmi.DateTime `xorm:"datetime 'DemandRecieveTime'" json:"LOG_ArtDemandLst-DemandRecieveTime"`
	DemandConfirmTime  grmi.DateTime `xorm:"datetime 'DemandConfirmTime'" json:"LOG_ArtDemandLst-DemandConfirmTime"`
	DemandCloseTime    grmi.DateTime `xorm:"datetime 'DemandCloseTime'" json:"LOG_ArtDemandLst-DemandCloseTime"`
	DemandDeliveredQty float64       `xorm:"float 'DemandDeliveredQty' not null" json:"LOG_ArtDemandLst-DemandDeliveredQty"`
	DemandCtrlPara1    int           `xorm:"int 'DemandCtrlPara1' not null" json:"LOG_ArtDemandLst-DemandCtrlPara1"`
	DemandCtrlPara2    int           `xorm:"int 'DemandCtrlPara2' not null" json:"LOG_ArtDemandLst-DemandCtrlPara2"`
	DemandCtrlPara3    string        `xorm:"nvarchar(100) 'DemandCtrlPara3' not null" json:"LOG_ArtDemandLst-DemandCtrlPara3"`
	DemandCtrlPara4    string        `xorm:"nvarchar(100) 'DemandCtrlPara4' not null" json:"LOG_ArtDemandLst-DemandCtrlPara4"`
	DemandCtrlTime1    grmi.DateTime `xorm:"datetime 'DemandCtrlTime1'" json:"LOG_ArtDemandLst-DemandCtrlTime1"`
	DemandCtrlTime2    grmi.DateTime `xorm:"datetime 'DemandCtrlTime2'" json:"LOG_ArtDemandLst-DemandCtrlTime2"`
	OrderStatus        string           `xorm:"int 'OrderStatus' not null" json:"LOG_ArtDemandLst-OrderStatus"`
	LastModify         grmi.DateTime `xorm:"datetime 'LastModify' not null updated" json:"LOG_ArtDemandLst-LastModify"`
	LastUser           string        `xorm:"nvarchar(20) 'LastUser' not null" json:"LOG_ArtDemandLst-LastUser"`
	CreateTime         grmi.DateTime `xorm:"datetime 'CreateTime' not null created" json:"LOG_ArtDemandLst-CreateTime"`
	ArtDesc            string        `json:"LOG_ArtDemandLst-ArtDesc"`       // 物料描述
	UrgencyDegree      string        `json:"LOG_ArtDemandLst-UrgencyDegree"` // 紧急程度
	SurplusDays        int64         `json:"LOG_ArtDemandLst-SurplusDays"`   // 距离交付天数
}

//TODO 临时结构体 待解决
type ArtDemandHeadResponseItemTemp struct {
	PlantNr            int           `xorm:"pk int 'PlantNr'" json:"LOG_ArtDemandHead-PlantNr"`
	ArtId              string        `xorm:"pk nvarchar(40) 'ArtId'" json:"LOG_ArtDemandHead-ArtId"`
	DemandId           string        `xorm:"pk nvarchar(40) 'DemandId'" json:"LOG_ArtDemandHead-DemandId"`
	DemandType         string        `xorm:"nvarchar(40) 'DemandType' not null" json:"LOG_ArtDemandHead-DemandType"`
	DemandYear         int           `xorm:"int 'DemandYear' not null" json:"LOG_ArtDemandHead-DemandYear"`
	DemandMonth        int           `xorm:"int 'DemandMonth' not null" json:"LOG_ArtDemandHead-DemandMonth"`
	DemandWeek         int           `xorm:"int 'DemandWeek' not null" json:"LOG_ArtDemandHead-DemandWeek"`
	DemandDate         grmi.Date     `xorm:"date 'DemandDate' not null" json:"LOG_ArtDemandHead-DemandDate"`
	DemandHour         int           `xorm:"int 'DemandHour' not null" json:"LOG_ArtDemandHead-DemandHour"`
	DemandTime         grmi.DateTime `xorm:"datetime 'DemandTime'" json:"LOG_ArtDemandHead-DemandTime"`
	DemandQty          float64       `xorm:"float 'DemandQty' not null" json:"LOG_ArtDemandHead-DemandQty"`
	QtyUomId           string        `xorm:"nvarchar(40) 'QtyUomId' not null" json:"LOG_ArtDemandHead-QtyUomId"`
	Status             string           `xorm:"int 'Status' not null" json:"LOG_ArtDemandHead-Status"`
	DemandSendTime     grmi.DateTime `xorm:"datetime 'DemandSendTime'" json:"LOG_ArtDemandHead-DemandSendTime"`
	DemandRecieveTime  grmi.DateTime `xorm:"datetime 'DemandRecieveTime'" json:"LOG_ArtDemandHead-DemandRecieveTime"`
	DemandConfirmTime  grmi.DateTime `xorm:"datetime 'DemandConfirmTime'" json:"LOG_ArtDemandHead-DemandConfirmTime"`
	DemandCloseTime    grmi.DateTime `xorm:"datetime 'DemandCloseTime'" json:"LOG_ArtDemandHead-DemandCloseTime"`
	DemandDeliveredQty float64       `xorm:"float 'DemandDeliveredQty' not null" json:"LOG_ArtDemandHead-DemandDeliveredQty"`
	DemandCtrlPara1    int           `xorm:"int 'DemandCtrlPara1' not null" json:"LOG_ArtDemandHead-DemandCtrlPara1"`
	DemandCtrlPara2    int           `xorm:"int 'DemandCtrlPara2' not null" json:"LOG_ArtDemandHead-DemandCtrlPara2"`
	DemandCtrlPara3    string        `xorm:"nvarchar(100) 'DemandCtrlPara3' not null" json:"LOG_ArtDemandHead-DemandCtrlPara3"`
	DemandCtrlPara4    string        `xorm:"nvarchar(100) 'DemandCtrlPara4' not null" json:"LOG_ArtDemandHead-DemandCtrlPara4"`
	DemandCtrlTime1    grmi.DateTime `xorm:"datetime 'DemandCtrlTime1'" json:"LOG_ArtDemandHead-DemandCtrlTime1"`
	DemandCtrlTime2    grmi.DateTime `xorm:"datetime 'DemandCtrlTime2'" json:"LOG_ArtDemandHead-DemandCtrlTime2"`
	OrderStatus        string           `xorm:"int 'OrderStatus' not null" json:"LOG_ArtDemandHead-OrderStatus"`
	LastModify         grmi.DateTime `xorm:"datetime 'LastModify' not null updated" json:"LOG_ArtDemandHead-LastModify"`
	LastUser           string        `xorm:"nvarchar(20) 'LastUser' not null" json:"LOG_ArtDemandHead-LastUser"`
	CreateTime         grmi.DateTime `xorm:"datetime 'CreateTime' not null created" json:"LOG_ArtDemandHead-CreateTim"`
	ArtDesc            string        `json:"LOG_ArtDemandHead-ArtDesc"`       // 物料描述
	UrgencyDegree      string        `json:"LOG_ArtDemandHead-UrgencyDegree"` // 紧急程度
	SurplusDays        int64         `json:"LOG_ArtDemandHead-SurplusDays"`   // 距离交付天数
}

// UrgencyDegree状态值
const (
	UrgencyNot     int = iota // 0 不紧急 绿色
	UrgencyNormal             // 1 紧急 黄色
	UrgencySerious            // 2 延误 红色
)
