// Copyright (c) Shenyang Leading Edge Intelligent Technology Co., Ltd. All rights reserved.

package implments

import (
	//logDal "LAPP_GAAS_GFrame_BACKEND/dao/log"
	dal "LAPP_GAAS_GFrame_BACKEND/dao/om"
	"LAPP_GAAS_GFrame_BACKEND/db"
	"LAPP_GAAS_GFrame_BACKEND/grmi"
	"LAPP_GAAS_GFrame_BACKEND/infra/logger"
	//logMeta "LAPP_GAAS_GFrame_BACKEND/meta/log"
	meta "LAPP_GAAS_GFrame_BACKEND/meta/om"
	baseModel "LAPP_GAAS_GFrame_BACKEND/models/base"
	//logModel "LAPP_GAAS_GFrame_BACKEND/models/log"
	model "LAPP_GAAS_GFrame_BACKEND/models/om"
	"LAPP_GAAS_GFrame_BACKEND/utils"
	"LAPP_GAAS_GFrame_BACKEND/web/models"
	"strconv"
	"time"
)

/******************************************************************************
 *
 * @Description              : WorkOrder的默认查询条件
 *
 * @Author                   : 代码生成器创建
 *
 * @Date                     : 2021-04-22 16:45:05
 *
 ******************************************************************************/
var DefaultConditionOfWorkOrder = grmi.NewCondition(
	map[string]grmi.ConditionItem{
		meta.WorkOrder_WorkOrderId.UrlParameterName:          grmi.NewConditionItem(meta.WorkOrder_WorkOrderId, grmi.Equal, true),
		meta.WorkOrder_ArtId.UrlParameterName:                grmi.NewConditionItem(meta.WorkOrder_ArtId, grmi.Equal, false),
		meta.WorkOrder_CustArtId.UrlParameterName:            grmi.NewConditionItem(meta.WorkOrder_CustArtId, grmi.Equal, false),
		meta.WorkOrder_RouteTemplateId.UrlParameterName:      grmi.NewConditionItem(meta.WorkOrder_RouteTemplateId, grmi.Equal, false),
		meta.WorkOrder_OrderType.UrlParameterName:            grmi.NewConditionItem(meta.WorkOrder_OrderType, grmi.Equal, false),
		meta.WorkOrder_OrderType1.UrlParameterName:           grmi.NewConditionItem(meta.WorkOrder_OrderType1, grmi.Equal, false),
		meta.WorkOrder_OrderType2.UrlParameterName:           grmi.NewConditionItem(meta.WorkOrder_OrderType2, grmi.Equal, false),
		meta.WorkOrder_OrderInfo.UrlParameterName:            grmi.NewConditionItem(meta.WorkOrder_OrderInfo, grmi.Equal, false),
		meta.WorkOrder_CustOrderId.UrlParameterName:          grmi.NewConditionItem(meta.WorkOrder_CustOrderId, grmi.Equal, false),
		meta.WorkOrder_ErpOrderId.UrlParameterName:           grmi.NewConditionItem(meta.WorkOrder_ErpOrderId, grmi.Equal, false),
		meta.WorkOrder_ParentOrderId.UrlParameterName:        grmi.NewConditionItem(meta.WorkOrder_ParentOrderId, grmi.Equal, false),
		meta.WorkOrder_Priority.UrlParameterName:             grmi.NewConditionItem(meta.WorkOrder_Priority, grmi.Equal, false),
		meta.WorkOrder_PlanResourceGroupId.UrlParameterName:  grmi.NewConditionItem(meta.WorkOrder_PlanResourceGroupId, grmi.Equal, false),
		meta.WorkOrder_PlanResourceId.UrlParameterName:       grmi.NewConditionItem(meta.WorkOrder_PlanResourceId, grmi.Equal, false),
		meta.WorkOrder_UsedResourceId.UrlParameterName:       grmi.NewConditionItem(meta.WorkOrder_UsedResourceId, grmi.Equal, false),
		meta.WorkOrder_PlanQty.UrlParameterName:              grmi.NewConditionItem(meta.WorkOrder_PlanQty, grmi.Equal, false),
		meta.WorkOrder_QtyUomId.UrlParameterName:             grmi.NewConditionItem(meta.WorkOrder_QtyUomId, grmi.Equal, false),
		meta.WorkOrder_RatePerHourToggle.UrlParameterName:    grmi.NewConditionItem(meta.WorkOrder_RatePerHourToggle, grmi.Equal, false),
		meta.WorkOrder_TimePerItemToggle.UrlParameterName:    grmi.NewConditionItem(meta.WorkOrder_TimePerItemToggle, grmi.Equal, false),
		meta.WorkOrder_TimePerBatchToggle.UrlParameterName:   grmi.NewConditionItem(meta.WorkOrder_TimePerBatchToggle, grmi.Equal, false),
		meta.WorkOrder_BatchTimeFieldToggle.UrlParameterName: grmi.NewConditionItem(meta.WorkOrder_BatchTimeFieldToggle, grmi.Equal, false),
		meta.WorkOrder_OpTimePerItem.UrlParameterName:        grmi.NewConditionItem(meta.WorkOrder_OpTimePerItem, grmi.Equal, false),
		meta.WorkOrder_BatchTime.UrlParameterName:            grmi.NewConditionItem(meta.WorkOrder_BatchTime, grmi.Equal, false),
		meta.WorkOrder_QuantityPerHour.UrlParameterName:      grmi.NewConditionItem(meta.WorkOrder_QuantityPerHour, grmi.Equal, false),
		meta.WorkOrder_BatchQuantity.UrlParameterName:        grmi.NewConditionItem(meta.WorkOrder_BatchQuantity, grmi.Equal, false),
		meta.WorkOrder_TimeUomId.UrlParameterName:            grmi.NewConditionItem(meta.WorkOrder_TimeUomId, grmi.Equal, false),
		meta.WorkOrder_BatchingMethod.UrlParameterName:       grmi.NewConditionItem(meta.WorkOrder_BatchingMethod, grmi.Equal, false),
		meta.WorkOrder_PlanStartDate.UrlParameterName:        grmi.NewConditionItem(meta.WorkOrder_PlanStartDate, grmi.Approximate, false),
		meta.WorkOrder_PlanEndDate.UrlParameterName:          grmi.NewConditionItem(meta.WorkOrder_PlanEndDate, grmi.Approximate, false),
		meta.WorkOrder_SetupStartTime.UrlParameterName:       grmi.NewConditionItem(meta.WorkOrder_SetupStartTime, grmi.Approximate, false),
		meta.WorkOrder_SetupEndTime.UrlParameterName:         grmi.NewConditionItem(meta.WorkOrder_SetupEndTime, grmi.Approximate, false),
		meta.WorkOrder_PlanStartTime.UrlParameterName:        grmi.NewConditionItem(meta.WorkOrder_PlanStartTime, grmi.Approximate, false),
		meta.WorkOrder_PlanEndTime.UrlParameterName:          grmi.NewConditionItem(meta.WorkOrder_PlanEndTime, grmi.Approximate, false),
		meta.WorkOrder_ActStartTime.UrlParameterName:         grmi.NewConditionItem(meta.WorkOrder_ActStartTime, grmi.Approximate, false),
		meta.WorkOrder_ActEndTime.UrlParameterName:           grmi.NewConditionItem(meta.WorkOrder_ActEndTime, grmi.Approximate, false),
		meta.WorkOrder_ProjectId.UrlParameterName:            grmi.NewConditionItem(meta.WorkOrder_ProjectId, grmi.Equal, false),
		meta.WorkOrder_CustomerId.UrlParameterName:           grmi.NewConditionItem(meta.WorkOrder_CustomerId, grmi.Equal, false),
		meta.WorkOrder_CustomerName.UrlParameterName:         grmi.NewConditionItem(meta.WorkOrder_CustomerName, grmi.Equal, false),
		meta.WorkOrder_FixStartTimeToggle.UrlParameterName:   grmi.NewConditionItem(meta.WorkOrder_FixStartTimeToggle, grmi.Equal, false),
		meta.WorkOrder_LastModify.UrlParameterName:           grmi.NewConditionItem(meta.WorkOrder_LastModify, grmi.Approximate, false),
		meta.WorkOrder_LastUser.UrlParameterName:             grmi.NewConditionItem(meta.WorkOrder_LastUser, grmi.Equal, false),
		meta.WorkOrder_CreateTime.UrlParameterName:           grmi.NewConditionItem(meta.WorkOrder_CreateTime, grmi.Approximate, false),
	},
	nil,
)

/******************************************************************************
 *
 * @Description              : WorkOrder的默认分页查询条件
 *
 * @Author                   : 代码生成器创建
 *
 * @Date                     : 2021-04-19 14:04:47
 *
 ******************************************************************************/
var DefaultConditionOfWorkOrderAndPaging = grmi.NewCondition(
	DefaultConditionOfWorkOrder.Items,
	grmi.NewPaging(),
)

/******************************************************************************
 *
 * @Struct Name              : WorkOrderServiceImplement
 *-----------------------------------------------------------------------------
 *
 * @Description              : WorkOrder的服务实现
 *
 * @Author                   : 代码生成器创建
 *
 * @Date                     : 2021-04-19 14:04:47
 *
 ******************************************************************************/
type WorkOrderServiceImplement struct {
}

/******************************************************************************
 *
 * @Function Name            : NewWorkOrderDAOImplement
 *-----------------------------------------------------------------------------
 *
 * @Description              : 创建一个WorkOrderDAOImplement实例
 *
 * @Return Value             : WorkOrderDAOImplement实例
 *
 * @Author                   : 代码生成器创建
 *
 * @Date                     : 2021-04-19 14:04:47
 *
 ******************************************************************************/
func NewWorkOrderServiceImplement() *WorkOrderServiceImplement {
	return &WorkOrderServiceImplement{}
}

/******************************************************************************
 *
 * @Reference LAPP_GAAS_GFrame_BACKEND/services/om/WorkOrderService.InsertOne
 *
 ******************************************************************************/
func (impl *WorkOrderServiceImplement) InsertOne(user *models.Usertab, entity *model.WorkOrderJoin) error {
	log, _ := logger.NewLogger(user.Userid, "OM")
	grmi.Log(user, "/services/om/implments/WorkOrder.service.impl.go", "InsertOneWorkOrder", "插入一个WorkOrder")

	engine := db.Eloquent.Master()
	session := engine.NewSession()
	err := session.Begin()
	if err != nil {
		return err
	}
	defer session.Close()

	dao := dal.NewWorkOrderDAO(session, user.Pid, user.Userid)
	statusDao := dal.NewWorkOrderStatusDAO(session, user.Pid, user.Userid)
	qtyDao := dal.NewWorkOrderQtyDAO(session, user.Pid, user.Userid)
	//artDemandHeadDao := logDal.NewArtDemandHeadDAO(session, user.Pid, user.Userid)
	//artDemandLstDao := logDal.NewArtDemandLstDAO(session, user.Pid, user.Userid)
	workOrder := entity.WorkOrder
	workQty := entity.WorkOrderQty
	workStatus := entity.WorkOrderStatus
	if workStatus.Status != baseModel.WO_STATUS_UNPLANNED {
		return grmi.NewBusinessError("创建的订单状态不合规,status:" + strconv.Itoa(entity.Status))
	}
	endTime := workOrder.PlanEndTime.Restore()
	startTime := workOrder.PlanStartTime.Restore()
	if endTime.Before(startTime) || endTime.Equal(startTime){
		return grmi.NewBusinessError("创建的订单状态计划时间不合规")
	}
	startDate := workOrder.PlanStartDate.Restore()
	endDate := workOrder.PlanEndDate.Restore()
	if endDate.Before(startDate) {
		return grmi.NewBusinessError("创建的订单状态计划时间不合规")
	}
	if workOrder.WorkOrderId == "" {
		snr := new(models.Snrtab)
		snr.Finr = user.Pid
		workOrderId, err := snr.GetNextSnr("WorkOrder")
		if err != nil {
			log.Error("workOrder InsertOne get work order id failed, error: " + err.Error())

			return err
		}
		workOrder.WorkOrderId = workOrderId
	}

	workQty.WorkOrderId = workOrder.WorkOrderId
	workStatus.WorkOrderId = workOrder.WorkOrderId
	err = dao.InsertOne(workOrder)
	if err != nil {
		log.Error("workOrder InsertOne insert workOrder failed, error: " + err.Error())
		session.Rollback()
		return err
	}
	err = statusDao.InsertOne(workStatus)
	if err != nil {
		log.Error("workOrder InsertOne insert workOrder status failed, error: " + err.Error())
		session.Rollback()
		return err
	}
	err = qtyDao.InsertOne(workQty)
	if err != nil {
		log.Error("workOrder InsertOne insert workOrder qty failed, error: " + err.Error())
		session.Rollback()
		return err
	}
	// 联动处理供应商门户
	//artDemandHeadLi, err := artDemandHeadDao.SelectByEndDate(workOrder.ArtId, workOrder.PlanEndDate.Restore().Format("2006-01-02"))
	//if err != nil {
	//	session.Rollback()
	//	log.Error("WorkOrder InsertOne get art demand head, error: " + err.Error())
	//
	//	return err
	//}
	//var demandId string
	//demandTime := workOrder.PlanEndTime.Restore()
	//weekIndex := utils.ParseWeekIndex(demandTime)
	//if len(artDemandHeadLi) == 0 {
	//	snr := new(models.Snrtab)
	//	snr.Finr = user.Pid
	//	demandId, err = snr.GetNextSnr("ArtDemand")
	//	if err != nil {
	//		session.Rollback()
	//		log.Error("WorkOrder InsertOne generate art demand id failed, error: " + err.Error())
	//
	//		return err
	//	}
	//	artDemandHead := logModel.ArtDemandHead{
	//		Source: logModel.DemandSourceInterval,
	//		UnproducedQty: workQty.PlanQty,
	//		DemandId:    demandId,
	//		ArtId:       workOrder.ArtId,
	//		DemandType:  "byDay",
	//		DemandYear:  demandTime.Year(),
	//		DemandMonth: int(demandTime.Month()),
	//		DemandWeek:  weekIndex,
	//		DemandTime:  workOrder.PlanEndTime,
	//		DemandDate:  grmi.Date(demandTime),
	//		DemandQty:   workQty.PlanQty,
	//		Status:      logModel.WaitReceivingStatus,
	//		OrderStatus: workStatus.Status,
	//		QtyUomId:    "",
	//	}
	//	err = artDemandHeadDao.InsertOne(&artDemandHead)
	//	if err != nil {
	//		session.Rollback()
	//		log.Error("WorkOrder InsertOne art demand failed, error: " + err.Error())
	//		return err
	//	}
	//
	//} else {
	//	artDemandHead := artDemandHeadLi[0]
	//	demandId = artDemandHead.DemandId
	//	artDemandHead.OrderStatus = workStatus.Status
	//	artDemandHead.DemandQty = workQty.PlanQty
	//	artDemandHead.UnproducedQty = workQty.PlanQty
	//	err = artDemandHeadDao.UpdateOne(&artDemandHead)
	//	if err != nil {
	//		session.Rollback()
	//		log.Error("WorkOrder InsertOne art demand failed, error: " + err.Error())
	//		return err
	//	}
	//	err = artDemandLstDao.DeleteWhere([]grmi.Predicate{logMeta.ArtDemandLst_DemandId.NewPredicate(grmi.Equal, demandId)})
	//	if err != nil {
	//		session.Rollback()
	//		log.Error("WorkOrder InsertOne art demandLst failed, error: " + err.Error())
	//
	//		return err
	//	}
	//}



	//artDemandLstLi := make([]logModel.ArtDemandLst, 0, workQty.PlanQty)
	//for i := 0; i < int(workQty.ActQty); i++ {
	//	artDemandLst := logModel.ArtDemandLst{
	//		DemandId:    demandId,
	//		ArtId:       workOrder.ArtId,
	//		DemandType:  "byDay",
	//		DemandYear:  demandTime.Year(),
	//		DemandMonth: int(demandTime.Month()),
	//		DemandWeek:  weekIndex,
	//		DemandTime:  workOrder.PlanEndTime,
	//		DemandDate:  grmi.Date(demandTime),
	//		DemandQty:   1,
	//		Status:     logModel.WaitReceivingStatus,
	//		OrderStatus:  workStatus.Status,
	//		QtyUomId:    "",
	//	}
	//	artDemandLstLi = append(artDemandLstLi, artDemandLst)
	//}
	//// 批量插入时 一次最多插入50条
	//demandLstTempLi := make([]logModel.ArtDemandLst, 0, 50)
	//for index, demandLst := range artDemandLstLi {
	//	if index%50 == 0 {
	//		err = artDemandLstDao.Insert(&demandLstTempLi)
	//		if err != nil {
	//			session.Rollback()
	//			log.Error("WorkOrder InsertOne art demandLst failed, error: " + err.Error())
	//			return err
	//		}
	//		demandLstTempLi = make([]logModel.ArtDemandLst, 0, 50)
	//	}
	//	demandLstTempLi = append(demandLstTempLi, demandLst)
	//}
	//if len(demandLstTempLi) != 0 {
	//	err = artDemandLstDao.Insert(&demandLstTempLi)
	//	if err != nil {
	//		session.Rollback()
	//		log.Error("WorkOrder InsertOne art demandLst failed, error: " + err.Error())
	//		return err
	//	}
	//}

	session.Commit()
	return nil
}

/******************************************************************************
 *
 * @Reference LAPP_GAAS_GFrame_BACKEND/services/om/WorkOrderService.DeleteOne
 *
 ******************************************************************************/
func (impl *WorkOrderServiceImplement) DeleteOne(user *models.Usertab, workOrderId string) error {
	grmi.Log(user, "/services/om/implments/WorkOrder.service.impl.go", "DeleteOneWorkOrder", "删除一个WorkOrder")
	log, _ := logger.NewLogger(user.Userid, "OM")
	engine := db.Eloquent.Master()
	session := engine.NewSession()
	err := session.Begin()
	if err != nil {
		return err
	}
	defer session.Close()
	dao := dal.NewWorkOrderDAO(session, user.Pid, user.Userid)
	statusDao := dal.NewWorkOrderStatusDAO(session, user.Pid, user.Userid)
	qtyDao := dal.NewWorkOrderQtyDAO(session, user.Pid, user.Userid)
	statusRecDao := dal.NewWorkOrderStatusRecLstDAO(session, user.Pid, user.Userid)
	//artDemandHeadDao := logDal.NewArtDemandHeadDAO(session, user.Pid, user.Userid)
	//artDemandLstDao := logDal.NewArtDemandLstDAO(session, user.Pid, user.Userid)
	record, err := dao.SelectOne(workOrderId)
	if err != nil {
		log.Error("WorkOrder DeleteOne select workOrder failed, error: " + err.Error())
		return err
	}
	if record == nil {
		return grmi.NewBusinessError("不存在指定workOrder记录!")
	}
	statusRecord, err := statusDao.SelectOne(workOrderId)
	if err != nil {
		log.Error("WorkOrder DeleteOne select workOrder status failed, error: " + err.Error())
		return err
	}
	if statusRecord == nil {
		return grmi.NewBusinessError("不存在指定workOrderStatus记录!")
	}
	qtyRecord, err := qtyDao.SelectOne(workOrderId)
	if err != nil {
		log.Error("WorkOrder DeleteOne select workOrder qty failed, error: " + err.Error())
		return err
	}
	if qtyRecord == nil {
		return grmi.NewBusinessError("不存在指定workOrderQty记录!")
	}
	if statusRecord.Status != baseModel.WO_STATUS_UNPLANNED {
		return grmi.NewBusinessError("该workOrder不可以删除, status:" + strconv.Itoa(statusRecord.Status))
	}
	//maxPos, err := statusRecDao.GetMaxPos(record.WorkOrderId)
	//if err != nil {
	//	log.Error("WorkOrder DeleteOne get status rec max pos failed, error: " + err.Error())
	//	session.Rollback()
	//	return err
	//}
	var workOrderStatusRec model.WorkOrderStatusRecLst
	workOrderStatusRec.WorkOrderId = record.WorkOrderId
	workOrderStatusRec.PrevStatus = statusRecord.Status
	workOrderStatusRec.Status = baseModel.WO_STATUS_CANCELED
	//workOrderStatusRec.Pos = maxPos + 1
	err = statusRecDao.InsertOne(&workOrderStatusRec)
	if err != nil {
		log.Error("WorkOrder DeleteOne insert status rec failed, error: " + err.Error())
		session.Rollback()
		return err
	}
	statusRecord.Status = baseModel.WO_STATUS_CANCELED
	err = statusDao.UpdateOne(statusRecord)
	if err != nil {
		log.Error("WorkOrder DeleteOne update work order status failed, error: " + err.Error())
		session.Rollback()
		return err
	}
	// 从供应商门户处处理对应的需求数据
	//artDemandHeadLi, err := artDemandHeadDao.SelectByEndDate(record.ArtId, record.PlanEndDate.Restore().Format("2006-01-02"))
	//if err != nil {
	//	log.Error("WorkOrder DeleteOne get art demand head failed, error: " + err.Error())
	//	session.Rollback()
	//	return err
	//}
	//if len(artDemandHeadLi) != 0 {
	//	artDemandHead := artDemandHeadLi[0]
	//	artDemandHead.OrderStatus = statusRecord.Status
	//	err = artDemandHeadDao.UpdateOne(&artDemandHead)
	//	if err != nil {
	//		log.Error("WorkOrder DeleteOne update art demand head failed, error: " + err.Error())
	//		session.Rollback()
	//		return err
	//	}
	//	//err = artDemandLstDao.DeleteWhere([]grmi.Predicate{logMeta.ArtDemandLst_DemandId.NewPredicate(grmi.Equal, artDemandHead.DemandId)})
	//	//if err != nil {
	//	//	log.Error("WorkOrder DeleteOne delete art demand lst failed, error: " + err.Error())
	//	//	session.Rollback()
	//	//	return err
	//	//}
	//}
	session.Commit()
	return nil
}

/******************************************************************************
 *
 * @Reference LAPP_GAAS_GFrame_BACKEND/services/om/WorkOrderService.SelectOne
 *
 ******************************************************************************/
func (impl *WorkOrderServiceImplement) SelectOne(user *models.Usertab, workOrderId string) (*model.WorkOrderJoin, error) {

	grmi.Log(user, "/services/om/implments/WorkOrder.service.impl.go", "SelectOneWorkOrder", "查询一个WorkOrder")

	engine := db.Eloquent.Master()
	session := engine.NewSession()
	defer session.Close()
	dao := dal.NewWorkOrderDAO(session, user.Pid, user.Userid)
	statusDao := dal.NewWorkOrderStatusDAO(session, user.Pid, user.Userid)
	qtyDao := dal.NewWorkOrderQtyDAO(session, user.Pid, user.Userid)
	workOrder, err := dao.SelectOne(workOrderId)
	if err != nil {
		return nil, err
	}
	if workOrder == nil {
		return nil, grmi.NewBusinessError("workOrder不存在")
	}
	workOrderStatus, err := statusDao.SelectOne(workOrderId)
	if err != nil {
		return nil, err
	}
	workOrderQty, err := qtyDao.SelectOne(workOrderId)
	if err != nil {
		return nil, err
	}
	data := &model.WorkOrderJoin{
		WorkOrder:       workOrder,
		WorkOrderQty:    workOrderQty,
		WorkOrderStatus: workOrderStatus,
	}

	return data, nil
}

/******************************************************************************
 *
 * @Reference LAPP_GAAS_GFrame_BACKEND/services/om/WorkOrderService.UpdateOne
 *
 ******************************************************************************/
func (impl *WorkOrderServiceImplement) UpdateOne(user *models.Usertab, entity *model.WorkOrderJoin) error {

	grmi.Log(user, "/services/om/implments/WorkOrder.service.impl.go", "UpdateOneWorkOrder", "修改一个WorkOrder")
	//log, _ := logger.NewLogger(user.Userid, "OM")

	engine := db.Eloquent.Master()
	session := engine.NewSession()
	if err := session.Begin(); err != nil {
		return err
	}
	defer session.Close()
	workOrder := entity.WorkOrder
	workOrderStatus := entity.WorkOrderStatus
	workOrderQty := entity.WorkOrderQty
	dao := dal.NewWorkOrderDAO(session, user.Pid, user.Userid)
	statusDao := dal.NewWorkOrderStatusDAO(session, user.Pid, user.Userid)
	qtyDao := dal.NewWorkOrderQtyDAO(session, user.Pid, user.Userid)
	//artDemandHeadDao := logDal.NewArtDemandHeadDAO(session, user.Pid, user.Userid)
	workOrderRecord, err := dao.SelectOne(workOrder.WorkOrderId)
	if err != nil {
		return err
	}
	if workOrderRecord == nil {
		return grmi.NewBusinessError("不存在指定记录!")
	}
	statusRecord, err := statusDao.SelectOne(workOrder.WorkOrderId)
	if err != nil {
		return err
	}
	if statusRecord == nil {
		return grmi.NewBusinessError("不存在指定的WorkOrderStatus")
	}
	qtyRecord, err := qtyDao.SelectOne(workOrder.WorkOrderId)
	if err != nil {
		return err
	}
	if qtyRecord == nil {
		return grmi.NewBusinessError("不存在指定的WorkOrderQty")
	}
	if workOrderStatus.Status != statusRecord.Status {
		return grmi.NewBusinessError("workOrderStatus不允许修改")
	}
	err = dao.UpdateOne(workOrder)
	if err != nil {
		session.Rollback()
		return err
	}
	workOrderQty.WorkOrderId = qtyRecord.WorkOrderId
	err = qtyDao.UpdateOne(workOrderQty)
	if err != nil {
		session.Rollback()
		return err
	}
	// 从供应商门户处处理对应的需求数据
	//artDemandHeadLi, err := artDemandHeadDao.SelectByEndDate(workOrderRecord.ArtId, workOrderRecord.PlanEndDate.Restore().Format("2006-01-02"))
	//if err != nil {
	//	log.Error("WorkOrder UpdateOne get art demand head failed, error: " + err.Error())
	//	session.Rollback()
	//	return err
	//}
	//if len(artDemandHeadLi) != 0 {
	//	artDemandHead := artDemandHeadLi[0]
	//	artDemandHead.OrderStatus = statusRecord.Status
	//	artDemandHead.DemandQty = qtyRecord.PlanQty
	//	artDemandHead.UnproducedQty = qtyRecord.PlanQty
	//	err = artDemandHeadDao.UpdateOne(&artDemandHead)
	//	if err != nil {
	//		log.Error("WorkOrder UpdateOne update art demand head failed, error: " + err.Error())
	//		session.Rollback()
	//		return err
	//	}
	//	//err = artDemandLstDao.DeleteWhere([]grmi.Predicate{logMeta.ArtDemandLst_DemandId.NewPredicate(grmi.Equal, artDemandHead.DemandId)})
	//	//if err != nil {
	//	//	log.Error("WorkOrder DeleteOne delete art demand lst failed, error: " + err.Error())
	//	//	session.Rollback()
	//	//	return err
	//	//}
	//}
	session.Commit()
	return nil
}

/******************************************************************************
 *
 * @Reference LAPP_GAAS_GFrame_BACKEND/services/om/WorkOrderService.Insert
 *
 ******************************************************************************/
func (impl *WorkOrderServiceImplement) Insert(user *models.Usertab, entities *[]model.WorkOrder) error {

	grmi.Log(user, "/services/om/implments/WorkOrder.service.impl.go", "InsertWorkOrder", "插入多个WorkOrder")

	engine := db.Eloquent.Master()
	session := engine.NewSession()
	defer session.Close()
	dao := dal.NewWorkOrderDAO(session, user.Pid, user.Userid)

	for _, entity := range *entities {
		record, err := dao.SelectOne(entity.WorkOrderId)
		if err != nil {
			return err
		}
		if record != nil {
			return grmi.NewBusinessError("已经存在相同主键的记录!")
		}
	}

	err := dao.Insert(entities)
	if err != nil {
		return err
	}
	return nil
}

/******************************************************************************
 *
 * @Reference LAPP_GAAS_GFrame_BACKEND/services/om/WorkOrderService.Delete
 *
 ******************************************************************************/
func (impl *WorkOrderServiceImplement) Delete(user *models.Usertab, entities *[]model.WorkOrder) error {

	grmi.Log(user, "/services/om/implments/WorkOrder.service.impl.go", "DeleteWorkOrder", "删除多个WorkOrder")

	engine := db.Eloquent.Master()
	session := engine.NewSession()
	defer session.Close()
	dao := dal.NewWorkOrderDAO(session, user.Pid, user.Userid)

	for _, entity := range *entities {
		record, err := dao.SelectOne(entity.WorkOrderId)
		if err != nil {
			return err
		}
		if record == nil {
			return grmi.NewBusinessError("不存在指定记录!")
		}
	}

	err := dao.Delete(entities)
	if err != nil {
		return err
	}
	return nil
}

/******************************************************************************
 *
 * @Reference LAPP_GAAS_GFrame_BACKEND/services/om/WorkOrderService.Select
 *
 ******************************************************************************/
func (impl *WorkOrderServiceImplement) Select(user *models.Usertab, urlParameters map[string]string) (interface{}, error) {

	grmi.Log(user, "/services/om/implments/WorkOrder.service.impl.go", "SelectWorkOrder", "查询WorkOrder")
	engine := db.Eloquent.Master()
	session := engine.NewSession()
	defer session.Close()
	var projectId string
	var artId string
	var timeStart string
	var timeEnd string
	var workOrderId string
	var orderType string
	var statusStr string
	var pageNumberStr string
	var pageSizeStr string
	projectId, _ = urlParameters["ProjectId"]
	artId, _ = urlParameters["ArtId"]
	workOrderId, _ = urlParameters["WorkOrderId"]
	timeStart, _ = urlParameters["start"]
	timeEnd, _ = urlParameters["end"]
	orderType, _ = urlParameters["OrderType"]
	statusStr, _ = urlParameters["status"]
	pageNumberStr, _ = urlParameters["pageNumber"]
	pageSizeStr, _ = urlParameters["pageSize"]
	status, err := strconv.Atoi(statusStr)
	if err != nil {
		status = 0
	}
	if timeStart != "" {
		_, err = time.ParseInLocation("2006-01-02 15:04:05", timeStart, utils.TimezoneLocation)
		if err != nil {
			return nil, err
		}
	}
	if timeEnd != "" {
		_, err = time.ParseInLocation("2006-01-02 15:04:05", timeEnd, utils.TimezoneLocation)
		if err != nil {
			return nil, err
		}
	}
	pageNumber, err := strconv.Atoi(pageNumberStr)
	if err != nil {
		pageNumber = 1
	}
	pageSize, err := strconv.Atoi(pageSizeStr)
	if err != nil {
		pageSize = 10
	}
	dao := dal.NewWorkOrderDAO(session, user.Pid, user.Userid)
	result, err := dao.SelectByPage(projectId, artId, timeStart, timeEnd, workOrderId, orderType, status, pageNumber, pageSize)
	if err != nil {
		return nil, err
	}
	return result, nil
}

/******************************************************************************
 *
 * @Reference LAPP_GAAS_GFrame_BACKEND/services/om/WorkOrderService.Update
 *
 ******************************************************************************/
func (impl *WorkOrderServiceImplement) Update(user *models.Usertab, entities *[]model.WorkOrder) error {

	grmi.Log(user, "/services/om/implments/WorkOrder.service.impl.go", "UpdateWorkOrder", "修改多个WorkOrder")

	engine := db.Eloquent.Master()
	session := engine.NewSession()
	defer session.Close()
	dao := dal.NewWorkOrderDAO(session, user.Pid, user.Userid)

	for _, entity := range *entities {
		record, err := dao.SelectOne(entity.WorkOrderId)
		if err != nil {
			return err
		}
		if record == nil {
			return grmi.NewBusinessError("不存在指定记录!")
		}
	}

	err := dao.Update(entities)
	if err != nil {
		return err
	}
	return nil
}

/******************************************************************************
 *
 * @Reference LAPP_GAAS_GFrame_BACKEND/services/om/WorkOrderService.Revocation
 *
 ******************************************************************************/
func (impl *WorkOrderServiceImplement) Revocation(user *models.Usertab, entities []string) error {

	grmi.Log(user, "/services/om/implments/WorkOrder.service.impl.go", "UpdateOneWorkOrder", "修改一个WorkOrder")

	engine := db.Eloquent.Master()
	session := engine.NewSession()
	defer session.Close()
	err := session.Begin()
	if err != nil {
		return err
	}
	dao := dal.NewWorkOrderDAO(session, user.Pid, user.Userid)
	statusDao := dal.NewWorkOrderStatusDAO(session, user.Pid, user.Userid)
	qtyDao := dal.NewWorkOrderQtyDAO(session, user.Pid, user.Userid)
	for _, workOrderId := range entities {
		workOrderRecord, err := dao.SelectOne(workOrderId)
		if err != nil {
			return err
		}
		if workOrderRecord == nil {
			return grmi.NewBusinessError("不存在指定记录!")
		}
		statusRecord, err := statusDao.SelectOne(workOrderId)
		if err != nil {
			return err
		}
		if statusRecord == nil {
			return grmi.NewBusinessError("不存在指定的WorkOrderStatus")
		}
		qtyRecord, err := qtyDao.SelectOne(workOrderId)
		if err != nil {
			return err
		}
		if qtyRecord == nil {
			return grmi.NewBusinessError("不存在指定的WorkOrderQty")
		}
		if statusRecord.Status > baseModel.WO_STATUS_PLANNED {
			return grmi.NewBusinessError("该订单状态不支持撤销,status:" + strconv.Itoa(statusRecord.Status))
		}
		statusRecord.Status = baseModel.WO_STATUS_UNPLANNED
		err = statusDao.UpdateOne(statusRecord)
		if err != nil {
			session.Rollback()
			return err
		}
	}
	session.Commit()
	return nil
}
