// Copyright (c) Shenyang Leading Edge Intelligent Technology Co., Ltd. All rights reserved.

package report

import (
	"LAPP_GAAS_GFrame_BACKEND/grmi"
	svr "LAPP_GAAS_GFrame_BACKEND/services/report"
	"github.com/kataras/iris/v12/core/router"
)

/******************************************************************************
*
* @Interface Name           : RegisterRoutes
*-----------------------------------------------------------------------------
*
* @Description              : 注册路由
*
* @Author                   : 代码生成器创建
*
* @Date                     : 2021-06-21 09:55:32
*
******************************************************************************/
func RegisterRoutes() {
	// 模块report路由分组
	grmi.RegisterRouteMapping("/report", func(party router.Party) {

		// FilterDataInfo的路由组
		filterdatainfo := party.Party("/filterdatainfo")
		// FilterDataInfo的服务实例
		var serviceOfFilterDataInfo = svr.NewFilterDataInfoService()
		// FilterDataInfo插入一条
		// RegisterInsertOneFilterDataInfo(filterdatainfo, "/insertone", serviceOfFilterDataInfo.InsertOne)
		// FilterDataInfo插入多条
		// RegisterInsertFilterDataInfo(filterdatainfo, "/insert", serviceOfFilterDataInfo.Insert)
		// FilterDataInfo删除一条
		// RegisterDeleteOneFilterDataInfo(filterdatainfo, "/deleteone", serviceOfFilterDataInfo.DeleteOne)
		// FilterDataInfo删除多条
		// RegisterDeleteFilterDataInfo(filterdatainfo, "/delete", serviceOfFilterDataInfo.Delete)
		// FilterDataInfo查询多条
		//RegisterSelectFilterDataInfo(filterdatainfo, "/query", serviceOfFilterDataInfo.Select)
		// FilterDataInfo查询一条
		//RegisterSelectOneFilterDataInfo(filterdatainfo, "/get", serviceOfFilterDataInfo.SelectOne)
		// FilterDataInfo修改一条
		// RegisterUpdateOneFilterDataInfo(filterdatainfo, "/updateone", serviceOfFilterDataInfo.UpdateOne)
		// FilterDataInfo修改多条
		// RegisterUpdateFilterDataInfo(filterdatainfo, "/update", serviceOfFilterDataInfo.Update)
		// 弧焊机数据统计展示
		RegisterGetArcDisplayData(filterdatainfo, "/display", serviceOfFilterDataInfo.GetDisplayData)
	})
}

/******************************************************************************
*
* @Interface Name           : init
*-----------------------------------------------------------------------------
*
* @Description              : 包初始化方法
*
* @Author                   : 代码生成器创建
*
* @Date                     : 2021-06-21 09:55:32
*
******************************************************************************/
func init() {

	// 注册路由
	RegisterRoutes()
}
